package net.pricefx.logic.core.model;

import java.util.Objects;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import net.pricefx.logic.core.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

import static net.pricefx.common.api.PriceFxInterface.TRACE_MARKER;


@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2017-11-10T15:30:45.019+01:00")
public class FormulaElementResult   {

  private static int MAX_RESULT_STR_CHARS = 300;

  protected String elementName = null;
  protected String elementLabel = null;
  protected String elementResultDescription = null;
  protected List<FormulaTraceMessage> traceMessages = new ArrayList<FormulaTraceMessage>();
  protected String alertMessage = null;
  protected List<String> warnings = new ArrayList<String>();
  protected String alertType = null;
  protected Long displayOptions = null;
  protected String formatType = null;
  protected Boolean overridden = null;
  protected Boolean overridable = null;
  protected Boolean summarize = null;
  protected Boolean hideOnNull = null;
  protected Boolean excludeFromExport = null;
  protected Boolean hideWarnings = null;
  protected String userGroup = null;
  protected String resultGroup = null;
  protected String labelTranslations = null;
  protected String suffix = null;
  protected String cssProperties = null;
  protected String cellStyles = null;
  protected List<Object> overrideValueOptions = new ArrayList<Object>();
  protected Boolean overrideAllowEmpty = null;
  protected String resultType = null;
  protected Long fieldType = null;
  protected Object elementResult = null;

  protected String elementResultStr = null;

  
  /**
   **/
  public FormulaElementResult elementName(String elementName) {
    this.elementName = elementName;
    return this;
  }
  
  @JsonProperty("elementName")
  public String getElementName() {
    return elementName;
  }
  public void setElementName(String elementName) {
    this.elementName = elementName;
  }

  
  /**
   **/
  public FormulaElementResult elementLabel(String elementLabel) {
    this.elementLabel = elementLabel;
    return this;
  }
  
  @JsonProperty("elementLabel")
  public String getElementLabel() {
    return elementLabel;
  }
  public void setElementLabel(String elementLabel) {
    this.elementLabel = elementLabel;
  }

  
  /**
   **/
  public FormulaElementResult elementResultDescription(String elementResultDescription) {
    this.elementResultDescription = elementResultDescription;
    return this;
  }
  
  @JsonProperty("elementResultDescription")
  public String getElementResultDescription() {
    return elementResultDescription;
  }
  public void setElementResultDescription(String elementResultDescription) {
    this.elementResultDescription = elementResultDescription;
  }

  
  /**
   **/
  public FormulaElementResult traceMessages(List<FormulaTraceMessage> traceMessages) {
    this.traceMessages = traceMessages;
    return this;
  }
  
  @JsonProperty("traceMessages")
  public List<FormulaTraceMessage> getTraceMessages() {
    return traceMessages;
  }
  public void setTraceMessages(List<FormulaTraceMessage> traceMessages) {
    this.traceMessages = traceMessages;
  }

  
  /**
   **/
  public FormulaElementResult alertMessage(String alertMessage) {
    this.alertMessage = alertMessage;
    return this;
  }
  
  @JsonProperty("alertMessage")
  public String getAlertMessage() {
    return alertMessage;
  }
  public void setAlertMessage(String alertMessage) {
    this.alertMessage = alertMessage;
  }

  
  /**
   **/
  public FormulaElementResult warnings(List<String> warnings) {
    this.warnings = warnings;
    return this;
  }
  
  @JsonProperty("warnings")
  public List<String> getWarnings() {
    return warnings;
  }
  public void setWarnings(List<String> warnings) {
    this.warnings = warnings;
  }

  
  /**
   **/
  public FormulaElementResult alertType(String alertType) {
    this.alertType = alertType;
    return this;
  }
  
  @JsonProperty("alertType")
  public String getAlertType() {
    return alertType;
  }
  public void setAlertType(String alertType) {
    this.alertType = alertType;
  }

  
  /**
   **/
  public FormulaElementResult displayOptions(Long displayOptions) {
    this.displayOptions = displayOptions;
    return this;
  }
  
  @JsonProperty("displayOptions")
  public Long getDisplayOptions() {
    return displayOptions;
  }
  public void setDisplayOptions(Long displayOptions) {
    this.displayOptions = displayOptions;
  }

  
  /**
   **/
  public FormulaElementResult formatType(String formatType) {
    this.formatType = formatType;
    return this;
  }
  
  @JsonProperty("formatType")
  public String getFormatType() {
    return formatType;
  }
  public void setFormatType(String formatType) {
    this.formatType = formatType;
  }

  
  /**
   **/
  public FormulaElementResult overridden(Boolean overridden) {
    this.overridden = overridden;
    return this;
  }
  
  @JsonProperty("overridden")
  public Boolean getOverridden() {
    return overridden;
  }
  public void setOverridden(Boolean overridden) {
    this.overridden = overridden;
  }

  
  /**
   **/
  public FormulaElementResult overridable(Boolean overridable) {
    this.overridable = overridable;
    return this;
  }
  
  @JsonProperty("overridable")
  public Boolean getOverridable() {
    return overridable;
  }
  public void setOverridable(Boolean overridable) {
    this.overridable = overridable;
  }

  
  /**
   **/
  public FormulaElementResult summarize(Boolean summarize) {
    this.summarize = summarize;
    return this;
  }
  
  @JsonProperty("summarize")
  public Boolean getSummarize() {
    return summarize;
  }
  public void setSummarize(Boolean summarize) {
    this.summarize = summarize;
  }

  
  /**
   **/
  public FormulaElementResult hideOnNull(Boolean hideOnNull) {
    this.hideOnNull = hideOnNull;
    return this;
  }
  
  @JsonProperty("hideOnNull")
  public Boolean getHideOnNull() {
    return hideOnNull;
  }
  public void setHideOnNull(Boolean hideOnNull) {
    this.hideOnNull = hideOnNull;
  }

  
  /**
   **/
  public FormulaElementResult hideWarnings(Boolean hideWarnings) {
    this.hideWarnings = hideWarnings;
    return this;
  }
  
  @JsonProperty("hideWarnings")
  public Boolean getHideWarnings() {
    return hideWarnings;
  }
  public void setHideWarnings(Boolean hideWarnings) {
    this.hideWarnings = hideWarnings;
  }


  @JsonProperty("excludeFromExport")
  public boolean getExcludeFromExport() {
    return excludeFromExport != null && excludeFromExport;
  }

  public void setExcludeFromExport(Boolean excludeFromExport) {
    this.excludeFromExport = excludeFromExport;
  }

  /**
   **/
  public FormulaElementResult userGroup(String userGroup) {
    this.userGroup = userGroup;
    return this;
  }
  
  @JsonProperty("userGroup")
  public String getUserGroup() {
    return userGroup;
  }
  public void setUserGroup(String userGroup) {
    this.userGroup = userGroup;
  }

  
  /**
   **/
  public FormulaElementResult resultGroup(String resultGroup) {
    this.resultGroup = resultGroup;
    return this;
  }
  
  @JsonProperty("resultGroup")
  public String getResultGroup() {
    return resultGroup;
  }
  public void setResultGroup(String resultGroup) {
    this.resultGroup = resultGroup;
  }

  
  /**
   **/
  public FormulaElementResult labelTranslations(String labelTranslations) {
    this.labelTranslations = labelTranslations;
    return this;
  }
  
  @JsonProperty("labelTranslations")
  public String getLabelTranslations() {
    return labelTranslations;
  }
  public void setLabelTranslations(String labelTranslations) {
    this.labelTranslations = labelTranslations;
  }

  
  /**
   **/
  public FormulaElementResult suffix(String suffix) {
    this.suffix = suffix;
    return this;
  }
  
  @JsonProperty("suffix")
  public String getSuffix() {
    return suffix;
  }
  public void setSuffix(String suffix) {
    this.suffix = suffix;
  }

  
  /**
   **/
  public FormulaElementResult cssProperties(String cssProperties) {
    this.cssProperties = cssProperties;
    return this;
  }
  
  @JsonProperty("cssProperties")
  public String getCssProperties() {
    return cssProperties;
  }
  public void setCssProperties(String cssProperties) {
    this.cssProperties = cssProperties;
  }

  
  /**
   **/
  public FormulaElementResult cellStyles(String cellStyles) {
    this.cellStyles = cellStyles;
    return this;
  }
  
  @JsonProperty("cellStyles")
  public String getCellStyles() {
    return cellStyles;
  }
  public void setCellStyles(String cellStyles) {
    this.cellStyles = cellStyles;
  }

  
  /**
   **/
  public FormulaElementResult overrideValueOptions(List<Object> overrideValueOptions) {
    this.overrideValueOptions = overrideValueOptions;
    return this;
  }
  
  @JsonProperty("overrideValueOptions")
  public List<Object> getOverrideValueOptions() {
    return overrideValueOptions;
  }
  public void setOverrideValueOptions(List<Object> overrideValueOptions) {
    this.overrideValueOptions = overrideValueOptions;
  }

  
  /**
   **/
  public FormulaElementResult overrideAllowEmpty(Boolean overrideAllowEmpty) {
    this.overrideAllowEmpty = overrideAllowEmpty;
    return this;
  }
  
  @JsonProperty("overrideAllowEmpty")
  public Boolean getOverrideAllowEmpty() {
    return overrideAllowEmpty;
  }
  public void setOverrideAllowEmpty(Boolean overrideAllowEmpty) {
    this.overrideAllowEmpty = overrideAllowEmpty;
  }

  
  /**
   **/
  public FormulaElementResult resultType(String resultType) {
    this.resultType = resultType;
    return this;
  }
  
  @JsonProperty("resultType")
  public String getResultType() {
    return resultType;
  }
  public void setResultType(String resultType) {
    this.resultType = resultType;
  }

  /**
   **/
  public FormulaElementResult fieldType(Long fieldType) {
    this.fieldType = fieldType;
    return this;
  }
  
  @JsonProperty("fieldType")
  public Long getFieldType() {
    return fieldType;
  }
  public void setFieldType(Long fieldType) {
    this.fieldType = fieldType;
  }

  
  /**
   **/
  public FormulaElementResult elementResult(Object elementResult) {
    this.elementResult = elementResult;
    return this;
  }
  
  @JsonProperty("elementResult")
  public Object getElementResult() {
    return elementResult;
  }
  public void setElementResult(Object elementResult) {
    this.elementResult = elementResult;
    this.elementResultStr = elementResult == null ? null : StringUtils.replaceLastThreeCharactersWithinLimitWithDots(elementResult.toString(), MAX_RESULT_STR_CHARS);
  }

  @JsonIgnore
  public String getElementResultStr() {
    return elementResultStr;
  }

  @JsonIgnore
  public boolean isTraceElement() {
    return org.apache.commons.lang3.StringUtils.startsWith(elementName, TRACE_MARKER);
  }

  @JsonIgnore
  public boolean isHyperLink() {
    return "LINK".equals(formatType);
  }

  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FormulaElementResult formulaElementResult = (FormulaElementResult) o;
    return Objects.equals(this.elementName, formulaElementResult.elementName) &&
        Objects.equals(this.elementLabel, formulaElementResult.elementLabel) &&
        Objects.equals(this.elementResultDescription, formulaElementResult.elementResultDescription) &&
        Objects.equals(this.traceMessages, formulaElementResult.traceMessages) &&
        Objects.equals(this.alertMessage, formulaElementResult.alertMessage) &&
        Objects.equals(this.warnings, formulaElementResult.warnings) &&
        Objects.equals(this.alertType, formulaElementResult.alertType) &&
        Objects.equals(this.displayOptions, formulaElementResult.displayOptions) &&
        Objects.equals(this.formatType, formulaElementResult.formatType) &&
        Objects.equals(this.overridden, formulaElementResult.overridden) &&
        Objects.equals(this.overridable, formulaElementResult.overridable) &&
        Objects.equals(this.summarize, formulaElementResult.summarize) &&
        Objects.equals(this.hideOnNull, formulaElementResult.hideOnNull) &&
        Objects.equals(this.hideWarnings, formulaElementResult.hideWarnings) &&
        Objects.equals(this.userGroup, formulaElementResult.userGroup) &&
        Objects.equals(this.resultGroup, formulaElementResult.resultGroup) &&
        Objects.equals(this.labelTranslations, formulaElementResult.labelTranslations) &&
        Objects.equals(this.suffix, formulaElementResult.suffix) &&
        Objects.equals(this.cssProperties, formulaElementResult.cssProperties) &&
        Objects.equals(this.cellStyles, formulaElementResult.cellStyles) &&
        Objects.equals(this.overrideValueOptions, formulaElementResult.overrideValueOptions) &&
        Objects.equals(this.overrideAllowEmpty, formulaElementResult.overrideAllowEmpty) &&
        Objects.equals(this.resultType, formulaElementResult.resultType) &&
        Objects.equals(this.fieldType, formulaElementResult.fieldType) &&
        Objects.equals(this.elementResult, formulaElementResult.elementResult);
  }

  @Override
  public int hashCode() {
    return Objects.hash(elementName, elementLabel, elementResultDescription, traceMessages, alertMessage, warnings, alertType, displayOptions, formatType, overridden, overridable, summarize, hideOnNull, hideWarnings, userGroup, resultGroup, labelTranslations, suffix, cssProperties, cellStyles, overrideValueOptions, overrideAllowEmpty, resultType, fieldType, elementResult);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class FormulaElementResult {\n");
    
    sb.append("    elementName: ").append(toIndentedString(elementName)).append("\n");
    sb.append("    elementLabel: ").append(toIndentedString(elementLabel)).append("\n");
    sb.append("    elementResultDescription: ").append(toIndentedString(elementResultDescription)).append("\n");
    sb.append("    traceMessages: ").append(toIndentedString(traceMessages)).append("\n");
    sb.append("    alertMessage: ").append(toIndentedString(alertMessage)).append("\n");
    sb.append("    warnings: ").append(toIndentedString(warnings)).append("\n");
    sb.append("    alertType: ").append(toIndentedString(alertType)).append("\n");
    sb.append("    displayOptions: ").append(toIndentedString(displayOptions)).append("\n");
    sb.append("    formatType: ").append(toIndentedString(formatType)).append("\n");
    sb.append("    overridden: ").append(toIndentedString(overridden)).append("\n");
    sb.append("    overridable: ").append(toIndentedString(overridable)).append("\n");
    sb.append("    summarize: ").append(toIndentedString(summarize)).append("\n");
    sb.append("    hideOnNull: ").append(toIndentedString(hideOnNull)).append("\n");
    sb.append("    hideWarnings: ").append(toIndentedString(hideWarnings)).append("\n");
    sb.append("    userGroup: ").append(toIndentedString(userGroup)).append("\n");
    sb.append("    resultGroup: ").append(toIndentedString(resultGroup)).append("\n");
    sb.append("    labelTranslations: ").append(toIndentedString(labelTranslations)).append("\n");
    sb.append("    suffix: ").append(toIndentedString(suffix)).append("\n");
    sb.append("    cssProperties: ").append(toIndentedString(cssProperties)).append("\n");
    sb.append("    cellStyles: ").append(toIndentedString(cellStyles)).append("\n");
    sb.append("    overrideValueOptions: ").append(toIndentedString(overrideValueOptions)).append("\n");
    sb.append("    overrideAllowEmpty: ").append(toIndentedString(overrideAllowEmpty)).append("\n");
    sb.append("    resultType: ").append(toIndentedString(resultType)).append("\n");
    sb.append("    fieldType: ").append(toIndentedString(fieldType)).append("\n");
    sb.append("    elementResult: ").append(toIndentedString(elementResult)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  protected String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

